#include <avr/io.h>
#include <util/delay.h>

#define c 1915
#define D 1700
#define E 1519
#define F 1432
#define G 1275
#define A 1136
#define B 1014
#define C 956

#define PAUSE 0

#define PAUSE1 1500
#define PAUSE2 3000

#define duration1 300
#define duration2 600
#define duration3 5200
#define duration4 10400

#define pause1 500
#define pause2 1000
#define pause3 1500

#define PAUSE 0
#define TEMPO 300

int points = 0;


void play_note(unsigned int note, int duration)
{
	// Reset the 16 bit Counter
	if(note != 0) {
		TCNT1H = 0;
		TCNT1L = 0;

		// Set the Counter TOP
		ICR1H = ( note >> 8 ) & 0x00FF;
		ICR1L = note;

		// Turn on the Prescaler
		TCCR1B |= (1<<CS11);
		switch(duration) {
			case 300:
			_delay_ms(duration1);
			break;
			case 600:
			_delay_ms(duration2);
			break;

		}
		// Turn off the Prescaler
		TCCR1B &= ~(1<<CS11);
		_delay_ms(TEMPO);
	}else {
		switch(duration) {
			case 300:
			_delay_ms(duration1);
			break;
			case 600:
			_delay_ms(duration2);
			break;

		}

	}

}

int is_pressed(int pin)
{
	return ((PINB & (1 << pin)) == 0);

}

void led_on(int pin) {
	PORTB |= (1 << pin);
}

void led_off(int pin) {
	 PORTB &= ~(1<< pin);
}

void led(int pin) {
    led_on(pin);
}


int main(void)
{
	//speaker

	DDRD = 0xFF;
    DDRD&= ~(1 << PD6);
    PORTD |= (1 << PD6);

	DDRB = 0xFF;
	PORTB = 0;

	// Buttons configuration
    DDRA = 0x00;
    PORTA = 0xFF;

	// Initial PWM (using Timer/Counter2)
	TCCR2A=0b10000011;            // Fast PWM Mode, Clear on OCRA
	TCCR2B=0b00000100;            // Used fclk/64 prescaler
	OCR2A=0;                      // Initial the OC2A (PB3) Out to 0

	// Set ADMUX Channel for Volume
	ADMUX=0x00;

	// Initial the ADC Circuit
	ADCSRA = (1<<ADEN) | (1<<ADPS2) | (1<<ADPS1);

	// Free running Mode
	ADCSRB = 0x00;

	// Disable digital input on ADC0
	DIDR0 = 0x01;

	// Set the Timer/Counter Control Register
	TCCR1A = (1<<COM1A1)|(1<<COM1A0); // Set OC1A when up counting, clear when down counting
	TCCR1B = (1<<WGM13);              // Phase/Freq-correct PWM, top value = ICR1

	repeat=0;
	//   PlayStatus=0;                     // Initial Play Status

	// for(;;) {
	// Start conversion by setting ADSC on ADCSRA Register
	ADCSRA |= (1<<ADSC);

	// wait until conversion complete ADSC=0 -> Complete
	while (ADCSRA & (1<<ADSC));

	// Get the 8 bit ADC Result
	OCR1AH=0;
	OCR1AL=ADCL;

    int notes[] = {c, c, D, c, F, E, c, c, D, c, G, F, c, c, C, A, F, E, D,
                    B, B, A, F, G, F, -1};

    int i = 0;
    while (notes[i] != -1) {
        switch(notes[i]) {
            case c :
                led(PB0);
                while (!(PIND & (1 << PD6)) == 0) {

        		}
               led_off(PB0);
                play_note(c,1 * TEMPO);
                break;
            case D:
                led(PB1);
                while (!(PINA & (1 << PA1)) == 0) {

                }
                led_off(PB1);
                play_note(D,1 * TEMPO);
                break;
            case E:
                led(PB2);
                while (!(PINA & (1 << PA2)) == 0) {

                }
                led_off(PB2);
                play_note(E, 1 * TEMPO);
                break;
            case F:
                led(PB3);
                while (!(PINA & (1 << PA3)) == 0) {

        		}
                led_off(PB3);
                play_note(F,1 * TEMPO);
                break;
            case G:
                led(PB4);
                while (!(PINA & (1 << PA4)) == 0) {

        		}
                led_off(PB4);
                play_note(G,1 * TEMPO);
                break;
            case A:
                led(PB5);
                while (!(PINA & (1 << PA5)) == 0) {

                }
                led_off(PB5);
                play_note(A,1 * TEMPO);
                break;
            case B:
                led(PB6);
                while (!(PINA & (1 << PA6)) == 0) {

        		}
                led_off(PB6);
                play_note(B,1 * TEMPO);
                break;
            case C:
                led(PB7);
                while (!(PINA & (1 << PA7)) == 0) {

        		}
                led_off(PB7);
                play_note(C,1 * TEMPO);
                break;
        }
        i++;
    }

	return 0;
}
